%% discussion de l'volution du rendement
%calcul en fct de epsilon1 et Q1
clc
clear
%% constantes
p1=10^5;
T1=298;
gamma=1.4;
cv=716.7;
rho=p1/287/T1; %kg/m3 ou g/L;
Q1=[100:50:550];
epsilon1=[6:0.5:12];
epsilon2=17.7;
V1=150;
V2=450;
vm2=V2/(epsilon2-1);
n1=size(epsilon1);
m1=size(Q1);
Wech=10^-6*p1*(V2-V1);
Wech_graph=ones(n1(2),m1(2))*Wech;
%% calculs et formation des tables
for i = 1:n1(2)
    for j=1:m1(2)
        %eta bdr
        eta_bdr(i,j)=1-epsilon1(i)^(1-gamma);
        Q2(i,j)=Q1(j)*(eta_bdr(i,j)-1);
        WBdr(i,j)=-Q1(j)*eta_bdr(i,j);
        %masse en oeuvre
        vm1(i,j)=V1/(epsilon1(i)-1);
        masse(i,j)=rho/1000*(V1+vm2+vm1(i,j));
        %T5 et p5
        T5(i,j)=-Q2(i,j)/(masse(i,j)/1000*cv)+T1;
        p5(i,j)=T5(i,j)/T1;
        %epsilon dtente prolonge
        epsilon_det(i,j)=(vm2+V2+vm1(i,j))/(V1+vm2+vm1(i,j));
        %travail dtente prolongee
        Wdet_prol(i,j)=0.1*p5(i,j)*(V1+vm2+vm1(i,j))/(gamma-1)*(epsilon_det(i,j)^(1-gamma)-1);
        %rendement
        eta_cycle(i,j)=abs((WBdr(i,j)+Wech+Wdet_prol(i,j))/Q1(j));
    end
end

%% graphes
scrsz = get(0,'ScreenSize');
figure('name','rendement du cycle 5T = f(Q1, epsilon1)','Position',[30 scrsz(4)/4 5*scrsz(3)/6 2*scrsz(4)/3],'NumberTitle','off')
subplot(2,2,1)
    meshz(Q1,epsilon1,eta_cycle)
    title ('rendement thorique _ epsilon2 = 17,7 _ Vcyl1=150 cm3 _ V2 = 450 cm3','fontsize',14)
    colormap copper
    xlabel ('Q1 (J)','fontsize',14)
    ylabel ('epsilon1','fontsize',14)
    g=gca;
    set(g,'fontsize',16)
subplot(2,2,2)
    [C,h]=contour(Q1,epsilon1,eta_cycle,'k','LineWidth',1);
    clabel(C,h)
    grid on
    title ('rendement thorique _ epsilon2 = 17,7 _ Vcyl1=150 cm3 _ V2 = 450 cm3','fontsize',14)
    xlabel ('Q1 (J)','fontsize',14)
    ylabel ('epsilon1','fontsize',14)
    text_handle = clabel(C,h);
    set(text_handle,'fontsize',14)
    g=gca;
    set(g,'fontsize',16)
 subplot(2,2,3)
    meshz(Q1,epsilon1,Wdet_prol)
    title ('travail de dtente prolonge _ epsilon2 = 17,7 _ Vcyl1=150 cm3 _ V2 = 450 cm3','fontsize',14)
    colormap copper
    xlabel ('Q1 (J)','fontsize',14)
    ylabel ('epsilon1','fontsize',14)
    h=gca;
    set(h,'fontsize',16)   
 subplot(2,2,4)
    meshz(Q1,epsilon1,Wech_graph)
    title ('travail chappement _ epsilon2 = 17,7 _ Vcyl1=150 cm3 _ V2 = 450 cm3','fontsize',14)
    colormap copper
    xlabel ('Q1 (J)','fontsize',14)
    ylabel ('epsilon1','fontsize',14)
    h=gca;
    set(h,'fontsize',14)       
