%% discussion de l'volution du rendement
%calcul en fct de epsilon2 et V2
clc
clear
%% constantes
p1=10^5;
T1=298;
gamma=1.4;
cv=716.7;
rho=p1/287/T1; %kg/m3 ou g/L
Q1=532.78;
epsilon1=7;
epsilon2=[10:1:20];
V1=150;
vm1=V1/(epsilon1-1);
V2=[200:100:1000];
n1=size(epsilon2);
m1=size(V2);
eta_bdr=1-epsilon1^-0.4;
WBdr=-Q1*eta_bdr;
Q2=Q1*(eta_bdr-1);
%% calculs _ formation des tables
for i = 1:n1(2)
    for j=1:m1(2)
        %masse en oeuvre
        vm2(i,j)=V2(j)/(epsilon2(i)-1);
        masse(i,j)=rho/1000*(V1+vm1+vm2(i,j));
        %T5 et p5
        T5(i,j)=-Q2/(masse(i,j)/1000*cv)+T1;
        p5(i,j)=T5(i,j)/T1;
        %epsilon dtente prolonge
        epsilon_det(i,j)=(vm1+V2(j)+vm2(i,j))/(V1+vm1+vm2(i,j));
        %travail dtente prolongee
        Wdet_prol(i,j)=0.1*p5(i,j)*(V1+vm1+vm2(i,j))/(gamma-1)*(epsilon_det(i,j)^(1-gamma)-1);
        %travail chappement
        Wech(i,j)=0.000001*p1*(V2(j)-V1);
        %rendement
        eta_cycle(i,j)=abs((WBdr+Wech(i,j)+Wdet_prol(i,j))/Q1);
    end
end

%% graphes
scrsz = get(0,'ScreenSize');
figure('name','rendement du cycle 5T = f(V2, epsilon2)','Position',[30 scrsz(4)/4 5*scrsz(3)/6 2*scrsz(4)/3],'NumberTitle','off')
subplot(2,2,1)
    meshz(V2,epsilon2,eta_cycle)
    title ('rendement thorique _ epsilon1 = 7 _ Vcyl1=150 cm3 _ Q1 = 530 J','fontsize',14)
    colormap copper
    xlabel( 'V2 (cm3)','fontsize',14)
    ylabel ('epsilon2','fontsize',14)
    g=gca;
    set(g,'fontsize',16)
subplot(2,2,2)
    [C,h]=contour(V2,epsilon2,eta_cycle,'k','LineWidth',1);
    clabel(C,h)
    grid on
    title ('rendement thorique  _ epsilon1 = 7 _ Vcyl1=150 cm3 _ Q1 = 530 J','fontsize',14)
    xlabel( 'V2 (cm3)','fontsize',14)
    ylabel ('epsilon2','fontsize',14)
   text_handle = clabel(C,h);
    set(text_handle,'fontsize',14)
    g=gca;
    set(g,'fontsize',16)
 subplot(2,2,3)
    meshz(V2,epsilon2,Wdet_prol)
    title ('travail de dtente prolonge _ epsilon1 = 7 _ Vcyl1=150 cm3 _ Q1 = 530 J','fontsize',14)
    colormap copper
    xlabel( 'V2 (cm3)','fontsize',14)
    ylabel ('epsilon2','fontsize',14)
    h=gca;
    set(h,'fontsize',14)   
 subplot(2,2,4)
    meshz(V2,epsilon2,Wech)
    title ('travail chappement _ epsilon1 = 7 _ Vcyl1=150 cm3 _ Q1 = 530 J','fontsize',14)
    colormap copper
   xlabel( 'V2 (cm3)','fontsize',14)
    ylabel ('epsilon2','fontsize',14)
    h=gca;
    set(h,'fontsize',14)       
